package com.qs.mp.web.controller.api.channel;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.qs.mp.channel.domain.ChannelGoodsSettleOrder;
import com.qs.mp.channel.domain.ChannelGoodsSettleOrderItem;
import com.qs.mp.channel.domain.vo.ChannelGoodsSettleItem;
import com.qs.mp.channel.domain.vo.ChannelSettleVO;
import com.qs.mp.channel.service.IChannelGoodsSettleOrderItemService;
import com.qs.mp.channel.service.IChannelGoodsSettleOrderService;
import com.qs.mp.common.core.domain.AjaxResult;
import com.qs.mp.common.core.page.TableDataInfo;
import com.qs.mp.web.controller.common.BaseApiController;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiResponse;
import io.swagger.annotations.ApiResponses;
import ma.glasnost.orika.MapperFacade;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;

/**
 * @author zhangkaikai
 * @create 2023-06-08 6:56 PM
 **/

@Api(tags = "我的结算")
@RestController
@RequestMapping("/api/v1/mp/channel/goods/*")
public class ChannelGoodsSettleController extends BaseApiController {

    @Autowired
    private IChannelGoodsSettleOrderService settleOrderService;

    @Autowired
    private IChannelGoodsSettleOrderItemService  settleOrderItemService;

    @Autowired
    private MapperFacade mapperFacade;


    @PostMapping("/settle/list")
    @ApiOperation("我的结算列表")
    @ApiResponses(
            @ApiResponse(code = 200, message = "成功", response = ChannelSettleVO.class)
    )
    public TableDataInfo list() {
        startPage();
        List<ChannelGoodsSettleOrder> list = settleOrderService.list();
        List<ChannelSettleVO> channelSettleVOS = mapperFacade.mapAsList(list, ChannelSettleVO.class);
        return getDataTable(channelSettleVOS);
    }

    @PostMapping("/settle/detail/{orderId}")
    @ApiOperation("我的结算详情")
    @ApiResponses(
            @ApiResponse(code = 200, message = "成功", response = ChannelSettleVO.class)
    )
    public AjaxResult detail(@PathVariable Long orderId) {
        ChannelGoodsSettleOrder settleOrder = settleOrderService.getById(orderId);
        ChannelSettleVO channelSettleVO = mapperFacade.map(settleOrder, ChannelSettleVO.class);
        List<ChannelGoodsSettleOrderItem> items = settleOrderItemService.list(new LambdaQueryWrapper<ChannelGoodsSettleOrderItem>().eq(ChannelGoodsSettleOrderItem::getOrderId, orderId));
        channelSettleVO.setItems(items);
        return AjaxResult.success(channelSettleVO);
    }
}
